#define ledRot1 8
#define ledRot2 7

#define ledGelb1 6
#define ledGelb2 5
#define ledGelb3 4

#define ledGruen1 3
#define ledGruen2 2

#define trigger 9
#define echo 10

#define buzzer 11

const int BUZZER_INTERVALL_ROT1 = 35;
const int BUZZER_INTERVALL_ROT2 = 100;

const int BUZZER_INTERVALL_GELB1 = 125;
const int BUZZER_INTERVALL_GELB2 = 250;
const int BUZZER_INTERVALL_GELB3 = 275;

const int BUZZER_INTERVALL_GRUEN1 = 450;
const int BUZZER_INTERVALL_GRUEN2 = 600;

int buzzerIntervall = 250;

void setup() {
  Serial.begin(9600);

  pinMode(ledRot1, OUTPUT);
  pinMode(ledRot2, OUTPUT);

  pinMode(ledGelb1, OUTPUT);
  pinMode(ledGelb2, OUTPUT);
  pinMode(ledGelb3, OUTPUT);

  pinMode(ledGruen1, OUTPUT);
  pinMode(ledGruen2, OUTPUT);

  pinMode(buzzer, OUTPUT);

  pinMode(trigger, OUTPUT); //Den Trigger auf das Output Signal des Sainsmart setzen.
  pinMode(echo, INPUT);  //Das Echo auf das Input Signal des Sainsmart setzen.
}

void loop() {
  float value = readUltrasonicValue();
  Serial.println(value);
  if (value > 0 && value < 5) {
    setCurrentStatus(1, 0, 0, 0, 0, 0, 0, BUZZER_INTERVALL_ROT1);
  } else if (value > 5 && value < 10) {
    setCurrentStatus(0, 1, 0, 0, 0, 0, 0, BUZZER_INTERVALL_ROT2);
  } else if (value > 10 && value < 15) {
    setCurrentStatus(0, 0, 1, 0, 0, 0, 0, BUZZER_INTERVALL_GELB1);
  } else if (value > 15 && value < 20) {
    setCurrentStatus(0, 0, 0, 1, 0, 0, 0, BUZZER_INTERVALL_GELB2);
  } else if (value > 20 && value < 25) {
    setCurrentStatus(0, 0, 0, 0, 1, 0, 0, BUZZER_INTERVALL_GELB3);
  } else if (value > 25 && value < 30) {
    setCurrentStatus(0, 0, 0, 0, 0, 1, 0, BUZZER_INTERVALL_GRUEN1);
  } else if (value > 30) {
    setCurrentStatus(0, 0, 0, 0, 0, 0, 1, BUZZER_INTERVALL_GRUEN2);
  }
}

void setCurrentStatus(int statusLedRot1,
                      int statusLedRot2,
                      int statusLedGelb1,
                      int statusLedGelb2,
                      int statusLedGelb3,
                      int statusLedGruen1,
                      int statusLedGruen2,
                      int buzzerIntervall) {
  digitalWrite(ledRot1, statusLedRot1);
  digitalWrite(ledRot2, statusLedRot2);
  digitalWrite(ledGelb1, statusLedGelb1);
  digitalWrite(ledGelb2, statusLedGelb2);
  digitalWrite(ledGelb3, statusLedGelb3);
  digitalWrite(ledGruen1, statusLedGruen1);
  digitalWrite(ledGruen2, statusLedGruen2);
  makeBeep(buzzerIntervall);
}

void makeBeep(int intervall) {
  tone(buzzer, 800, 45);
  delay(intervall);
}

float readUltrasonicValue() {
  digitalWrite(trigger, LOW); //Trigger Signal ausschalten
  delayMicroseconds(2);   //2 ms warten
  digitalWrite(trigger, HIGH);  //Trigger Signal einschalten
  delayMicroseconds(10);  //10ms warten
  digitalWrite(echo, LOW); //Trigger Signal ausschalten
  float cm = pulseIn(echo, HIGH) / 58.0; //Das Empfangene Echo Signal in cm umrechnen
  //Da der Sensor mit einer Messgenauigkeit von 0,3cm arbeitet können wir das
  //Ergbnis auf 2 Nachkommastellen begrenzen
  return (int(cm * 100.0)) / 100.0;

}
